const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const clientes = sequelize.define(
    'clientes',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      name: {
        type: DataTypes.TEXT,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  clientes.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    db.clientes.hasMany(db.users, {
      as: 'users_clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.clientes.hasMany(db.cameras_ptz, {
      as: 'cameras_ptz_clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.clientes.hasMany(db.epcs, {
      as: 'epcs_clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.clientes.hasMany(db.epis, {
      as: 'epis_clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.clientes.hasMany(db.equipes_trabalho, {
      as: 'equipes_trabalho_clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.clientes.hasMany(db.estrutura_projeto, {
      as: 'estrutura_projeto_clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.clientes.hasMany(db.etapas_ou_trechos, {
      as: 'etapas_ou_trechos_clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.clientes.hasMany(db.frames_imagem, {
      as: 'frames_imagem_clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.clientes.hasMany(db.gemeos_digitais, {
      as: 'gemeos_digitais_clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.clientes.hasMany(db.historico_alteracoes_projeto, {
      as: 'historico_alteracoes_projeto_clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.clientes.hasMany(db.inspecao_aerea, {
      as: 'inspecao_aerea_clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.clientes.hasMany(db.maquinas_atividade, {
      as: 'maquinas_atividade_clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.clientes.hasMany(db.materiais_atividade, {
      as: 'materiais_atividade_clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.clientes.hasMany(db.membros_equipe, {
      as: 'membros_equipe_clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.clientes.hasMany(db.memoriais_descritivos_asbuilt, {
      as: 'memoriais_descritivos_asbuilt_clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.clientes.hasMany(db.modelos_bim_asbuilt, {
      as: 'modelos_bim_asbuilt_clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.clientes.hasMany(db.obras, {
      as: 'obras_cliente',
      foreignKey: {
        name: 'clienteId',
      },
      constraints: false,
    });

    db.clientes.hasMany(db.obras, {
      as: 'obras_clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.clientes.hasMany(db.permissoes_modulo, {
      as: 'permissoes_modulo_clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.clientes.hasMany(db.pessoas_atividade, {
      as: 'pessoas_atividade_clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.clientes.hasMany(db.pessoas_frame, {
      as: 'pessoas_frame_clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.clientes.hasMany(db.plantas_asbuilt_2d, {
      as: 'plantas_asbuilt_2d_clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.clientes.hasMany(db.relatorio_andamento_atual, {
      as: 'relatorio_andamento_atual_clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.clientes.hasMany(db.relatorios_analiticos_video, {
      as: 'relatorios_analiticos_video_clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.clientes.hasMany(db.relatorios_diarios, {
      as: 'relatorios_diarios_clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.clientes.hasMany(db.relatorios_mensais, {
      as: 'relatorios_mensais_clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.clientes.hasMany(db.relatorios_semanais, {
      as: 'relatorios_semanais_clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.clientes.hasMany(db.subcontratadas, {
      as: 'subcontratadas_clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.clientes.hasMany(db.usuarios, {
      as: 'usuarios_cliente',
      foreignKey: {
        name: 'clienteId',
      },
      constraints: false,
    });

    db.clientes.hasMany(db.usuarios, {
      as: 'usuarios_clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    //end loop

    db.clientes.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.clientes.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return clientes;
};
